(* envoie s  TCL-TK pour valuation. s ne doit pas contenir de saut de ligne.*)
let send_tk s =
  print_string ("\n&&&&" ^ s);
  print_newline ();;

let canvas_name = ref "";;

let open_canvas =
  let nombre_canvas = ref 0 in
  fun l h ->
    if !canvas_name = ""
      then 
        (
        incr nombre_canvas;        
        canvas_name := "$ww.text.w" ^ (string_of_int !nombre_canvas)
        );    
    send_tk (Printf.sprintf "open_graph {%f} {%f}" l h);;
  
let close_canvas () =
  canvas_name := "";
  send_tk "close_graph";;

let draw_circle
    ?(fill = "white")
    ?(outline = "black")
    ?(text = "") 
    ~d x y =
  let r = d *. 0.5 in
  send_tk
    (
    Printf.sprintf
      "$canvas_name create oval %fm %fm %fm %fm -fill %s -outline %s" 
        (x -. r) (y -. r) (x +. r) (y +. r) fill outline
    );
  if text <> ""
    then
      send_tk
        (
        Printf.sprintf
          "$canvas_name create text %fm %fm -text {%s}" x y text
        );;
         
let draw_line
    ?(fill = "black")
    x1 y1 x2 y2 =
  send_tk
    (
    Printf.sprintf
      "$canvas_name create line %fm %fm %fm %fm -fill %s" x1 y1 x2 y2 fill
    );; 

let draw_text s x y =
      send_tk
        (
        Printf.sprintf
          "$canvas_name create text %fm %fm -text {%s} -tag movable" x y s
        );;



