#load "es.cmo";;
#load "arbre.cmo";;

let id s = s in

print_string "Un arbre:";
Arbre.affiche_elementgraphique
  id (Arbre.Arbre(Arbre.arbre_of_string
        "1(2(3()4())5(6())7(8(9())10())11()))"));

print_string "Une fort:";
Arbre.affiche_elementgraphique
  ~ca:"red"
  ~cn:"yellow"
  id (Arbre.Foret(Arbre.foret_of_string"(0(2()3()4())1(5()))"));

print_string "Un arbre binaire:";
Random.init 314;
let rec arbre_ala = function
  0 -> Arbre.Nil |
  n -> let k = Random.int n in 
       Arbre.Noeud(arbre_ala k,"",arbre_ala(n-1-k)) in
Arbre.affiche_elementgraphique
  ~ca:"black"
  ~cn:"black"
  ~d:1.
  ~eh:2.5
  ~ev:2.5
  id (Arbre.Arbrebinaire(arbre_ala 100));;

#load "graphe.cmo";;
#load "auto.cmo";;

let affiche_er e =
  let rec arbre_of_er = function
    | Auto.V s -> {Arbre.etiquette = s; Arbre.branches = []}
    | Auto.C s -> {Arbre.etiquette = s; Arbre.branches = []}
    | Auto.U(s,e) -> {Arbre.etiquette = s; Arbre.branches = [arbre_of_er e]}
    | Auto.B(s,e,e') ->
        let s = if s = "" then "." else s in
        {Arbre.etiquette = s; Arbre.branches = [arbre_of_er e;arbre_of_er e']} in
  Arbre.affiche_elementgraphique (function s -> s) (Arbre.Arbre(arbre_of_er e)) in

print_string "Une expression rationnelle:";  
affiche_er (Auto.er_of_string "(a+b)*aba");;

