     
type ('a,'b) graphe = ('a * ((int * 'b) list)) array;;

let ecarts_graphe (g : ('a,'b) graphe) =
  let n = Array.length g in
  let boucle,libre0,libre2 =
    let boucle = Array.make n (-1)
    and libre0 = Array.make n false
    and libre2 = Array.make n false
    and a = Array.make n false
    and b = Array.make n false
    and c = Array.make n false
    and d = Array.make n false
    and e = Array.make n false
    and f = Array.make n false in
    for i = 0 to n - 1 do
      List.iter
        (
        function j,_ ->
          let aux x y =
            x.(i) <- true;
            y.(j) <- true in
          if      j = i + 1 then aux a c
          else if j = i - 1 then aux d b
          else if j > i     then aux e e
          else if j < i     then aux f f
          else boucle.(i) <- 1
        )
        (snd g.(i))
    done;
    for i = 0 to n - 1 do
      let e0 = a.(i) || b.(i)
      and e1 = e.(i)
      and e2 = c.(i) || d.(i)
      and e3 = f.(i) || (c.(i) && d.(i)) || (a.(i) && b.(i)) in
      if boucle.(i) = 1 && e1
        then
          boucle.(i) <- if not e3 then 3 else 
                        if not e0 then 0 else 
                        if not e2 && not (i <> 0 && boucle.(i-1) = 0) then 2 else
                        3;
      libre2.(i) <- not (e2 || boucle.(i) = 2);
      libre0.(i) <- not (e0 || boucle.(i) = 0);
    done;
    boucle,libre0,libre2 in
  let arcs =
    let arcs = ref [] in
    for i = 0 to n - 1 do
      List.iter (function j,v -> arcs := (i,j,v) :: !arcs) (snd g.(i))
    done;
    arcs := 
      List.sort
        ~cmp:(
             fun (i,j,_) (i',j',_) -> 
               let d = j - i and d' = j' - i' in
               if d * d' < 0 then d'
               else abs d - abs d'
             ) 
             !arcs;
    !arcs
  and u = Array.make n 1
  and v = Array.make n 0
  and u' = Array.make n 1
  and v' = Array.make n 0
  and hmax = ref 0
  and hmax' = ref 0
  and g' = Array.make n [] 
  and calc_h u v i j =
    let e = ref v.(j) in
    for k = i + 1 to j - 1 do
      e := !e lor v.(k) lor u.(k)
    done;
    let h =
      let rec min = function
        | 0 -> failwith "graphe impossible  dessiner: trop d'arcs"
        | e -> match e land 1 with | 0 -> 1 + min(e lsr 1) | _ -> 0 in
      min (lnot !e) in
    for k = i + 1 to j do
      v.(k) <- v.(k) lor (1 lsl h)
    done; 
    h in
  List.iter
    (
    function i,j,w ->
      let h =
        if i = j then
          (
          (
          match boucle.(i) with
            | 1 -> u.(i) <- 3; 
                   if !hmax = 0 then hmax := 1
            | 3 -> u'.(i) <- 3; 
                   if !hmax' = 0 then hmax' := 1
            | _ -> ()
          );
          1
          )
        else if j > i then
          (
          if j = i + 1 then v'.(j) <- 1;
          let h = calc_h u v i j in
          if !hmax < h then hmax := h;
          h
          )
        else
          let h = calc_h u' v' j i in
          if !hmax' < h then hmax' := h;
          h in
      g'.(i) <- (h,j,w) :: g'.(i)
    )
    arcs;
  g',n,!hmax,!hmax',boucle,libre0,libre2;;

type ('a,'b) structuregraphique =
   {
   elementgraphique    : ('a,'b) graphe;
   oriente             : bool;
   flecherentrante     : bool array;
   flechesortante      : bool array;
   longueurfleche      : float;
   fonctionsommet      : 'a -> string * string; (* couleur,tiquette *)
   fonctionarc         : 'b -> string * string; (* couleur,valuation *)
   ecarthorizontal     : float; (* distance entre deux sommets *)
   ecartvertical       : float; (* distance verticale entre 2 arcs *)
   diametresommet      : float; (* exact *)
   largeurboucle       : float;
   distancevaluation   : float; (* distance de la valuation  l'arc *)
   hauteurvaluation    : float; (* estimation de la hauteur des caractres *)
   trespetitecart      : float; (* cart entre les bouts d'arcs verticaux*)
   petitecart          : float; (* cart laissant la place  une flche *)
   rayonangle          : float;
   margehorizontale    : float  (* ne pas tenir compte des ventuelles boucles et flches *)
   };;
  
let draw_structuregraphique s =
  let g,n,h,h',boucle,libre0,libre2 = ecarts_graphe s.elementgraphique in
  let rayonsommet = s.diametresommet *. 0.5 in
  let h = (float_of_int h) *. s.ecartvertical
  and h' = (float_of_int h') *. s.ecartvertical
  and xx = Array.make n 0. (* abscisses des sommets *)
  and fleche_r = Array.make n (-1) (* positions des flches rentrantes: 1,2,3*)
  and fleche_s = Array.make n (-1) in (* flches sortantes 0,1,3*) 
  let y =
    if h = 0. then rayonsommet +. s.hauteurvaluation
    else h +. s.distancevaluation +. s.hauteurvaluation
  and y' =
    if h' = 0. then rayonsommet +. s.hauteurvaluation
    else h' +. s.distancevaluation +. s.hauteurvaluation in
  for i = 0 to n - 1 do
    if s.flecherentrante.(i) then
      fleche_r.(i) <- 
        if libre2.(i) then 2
        else  if boucle.(i) <> 1 then 1
        else 3;
    if s.flechesortante.(i) then
      fleche_s.(i) <- 
        if libre0.(i) then 0
        else  if boucle.(i) <> 1 then 1
        else 3
  done;
  let lfleche = rayonsommet +. s.longueurfleche in
  let margegauche =
    s.margehorizontale +. 
     (
     if boucle.(0) = 2 
       then s.ecartvertical +. s.distancevaluation +. s.hauteurvaluation else
     if fleche_r.(0) = 2
       then lfleche else
     rayonsommet
     )
  and margedroite =
    s.margehorizontale +. 
     (
     if boucle.(n-1) = 0 
       then s.ecartvertical +. s.distancevaluation +. s.hauteurvaluation else
     if fleche_s.(n-1) = 0 
       then lfleche else
     rayonsommet
     ) in
  let largeurtotale = 
    margegauche +. float_of_int(n-1) *. s.ecarthorizontal +. margedroite
  and hauteurtotale =
    y +. y' in
  for i = 0 to n - 1 do
    xx.(i) <- margegauche +. float_of_int i *. s.ecarthorizontal
  done;
  let trace_arc x y x' y' h couleur texte position b =
    let u,v = match position with
      | 0 -> 1.,0. | 1 -> 0.,-.1. | 2 -> -.1.,0. | _ -> 0.,1. in
    let u',v' = -.v,u
    and r = s.rayonangle in
    let h' = h -. r in
    let x1,y1 = x +. h' *. u , y +. h' *. v
    and x2,y2 = x' +. h' *. u , y' +. h' *. v in
    let x3,y3 = x1 +. r *. u' , y1 +. r *. v'
    and x4,y4 = x2 -. r *. u' , y2 -. r *. v' in
    let x5,y5 = x3 +. r *. u , y3 +. r *. v
    and x6,y6 = x4 +. r *. u , y4 +. r *. v in
    let x7,y7 = 0.5 *. (x5 +. x6) , 0.5 *. (y5 +. y6) in
    let x8,y8 = x5 +. r *. u' , y5 +. r *. v'
    and x9,y9 = x6 -. r *. u' , y6 -. r *. v'
    and x10,y10 = x1 -. r *. u , y1 -. r *. v
    and x11,y11 = x2 -. r *. u , y2 -. r *. v in
    Es.draw_line ~fill:couleur x y x1 y1;
    Es.send_tk
    (
    Printf.sprintf
      "$canvas_name create arc %fm %fm %fm %fm -style arc -outline %s -start %i -extent 90"
        x8 y8 x10 y10 couleur (position * 90) 
    );
    if s.oriente
      then 
        if b then
          Es.send_tk
           (
           Printf.sprintf
             "$canvas_name create line %fm %fm %fm %fm -fill %s -arrow last -arrowshape {1.5m 2.5m 0.8m}"
               x5 y5 x6 y6 couleur 
           )
        else
          (
          Es.send_tk
           (
           Printf.sprintf
             "$canvas_name create line %fm %fm %fm %fm -fill %s -arrow last -arrowshape {1.5m 2.5m 0.8m}"
               x5 y5 x7 y7 couleur 
           );
          Es.draw_line ~fill:couleur x7 y7 x6 y6
          )
      else
        Es.draw_line ~fill:couleur x5 y5 x6 y6;
    Es.send_tk
    (
    Printf.sprintf
      "$canvas_name create arc %fm %fm %fm %fm -style arc -outline %s -start %i -extent 90"
        x9 y9 x11 y11 couleur ((position - 1) * 90) 
    );
    Es.draw_line ~fill:couleur x2 y2 x' y';
    if texte <> ""
      then
        (
        let dv = s.distancevaluation in
        let x12,y12 = x7 +. dv *. u , y7 +. dv *. v 
        and ancre = match position with
          | 0 -> "w"
          | 1 -> "s"
          | 2 -> "e"
          | _ -> "n" in
        Es.send_tk
          (
          Printf.sprintf
            "$canvas_name create text %fm %fm -text {%s} -anchor %s"
              x12 y12 texte ancre
          )
        ) in
  Es.open_canvas largeurtotale hauteurtotale;
  for i = 0 to n - 1 do (* trac des arcs et des boucles *)
    List.iter
     (
     function (haut,j,v) ->
       let h = float_of_int haut *. s.ecartvertical 
       and l = s.largeurboucle *. 0.5
       and pe = s.petitecart *. 0.5 in
       let ge = l +. s.trespetitecart
       and couleur,texte = s.fonctionarc v in
       if j <> i && haut = 0 then (*arc rectiligne*)
         (
         let x' = 0.5 *. (xx.(i) +. xx.(j)) in
         if s.oriente then
           (
           Es.send_tk
             (
             Printf.sprintf
               "$canvas_name create line %fm %fm %fm %fm -fill %s -arrow last -arrowshape {1.5m 2.5m 0.8m}"
                 xx.(i) y x' y couleur 
             );
           Es.draw_line ~fill:couleur x' y xx.(j) y
           )
         else
           Es.draw_line ~fill:couleur xx.(i) y xx.(j) y;
         if texte <> "" then
           Es.send_tk
             (
             Printf.sprintf
               "$canvas_name create text %fm %fm -text {%s} -anchor s"
                 x' (y -. s.distancevaluation) texte
             ) 
         )
       else if j = i then (*boucle*)
         (
         let x,y,x',y' = match boucle.(i) with
           | 0 -> xx.(i),y -. l,xx.(i),y +. l
           | 1 -> xx.(i) -. l,y,xx.(i) +. l,y
           | 2 -> xx.(i),y +. l,xx.(i),y -. l
           | _ -> xx.(i) +. l,y,xx.(i) -. l,y in
         trace_arc x y x' y' s.ecartvertical couleur texte boucle.(i) true
         )
       else if j > i then (*arc avant*) 
         (
         let x = xx.(i) +. (if boucle.(i) = 1 then ge else pe)
         and x' = xx.(j) -. (if boucle.(j) = 1 then ge else pe) in
         trace_arc x y x' y h couleur texte 1 false
         )
       else (*arc arrire*)
         (
         let x = xx.(i) -. (if boucle.(i) = 3 then ge else pe)
         and x' = xx.(j) +. (if boucle.(j) = 3 then ge else pe) in
         trace_arc x y x' y h couleur texte 3 false
         )
     )
     g.(i)
  done;
  let rac = 0.7071  in
  let trace_fleche i position b = (*b = true si rentrante*)
    if position >= 0 then
      (
      let u,v = match position,b with
        | 0,_ -> 1.,0.
        | 2,_ -> -.1.,0.
        | 1,true -> -.rac,-.rac
        | 1,false -> rac,-.rac
        | 3,true -> -.rac,rac
        | _ -> rac,rac
      and lf = s.longueurfleche in
      let x,y = xx.(i) +. rayonsommet *. u,y +. rayonsommet *. v in
      let x',y' = x +. lf *. u,y +. lf *. v in
      Es.send_tk
        (
        Printf.sprintf
          "$canvas_name create line %fm %fm %fm %fm -arrow %s"
            x y x' y' (if b then "first" else "last") 
        )
      ) in
  for i = 0 to n - 1 do (*trac des flches*)
    trace_fleche i fleche_r.(i) true;
    trace_fleche i fleche_s.(i) false
  done;
  for i = 0 to n - 1 do (*trac des sommets*)
    let couleur,texte = s.fonctionsommet(fst s.elementgraphique.(i)) in
    Es.draw_circle ~fill:couleur ~text:texte ~d:s.diametresommet xx.(i) y 
  done;
  Es.close_canvas();;

let affiche_graphe
    ?(cs = "DeepSkyBlue3")
    ?(d  = 7.)
    ?(eh = 16.)
    ?(ehp = 2.)
    ?(ehpp = 0.8)
    ?(lb = 5.)
    ?(mh = 0.1)
    ?(ca = "DeepSkyBlue4")
    ?(ra = 1.5)
    ?(ev = 5.5)
    ?(dv = 0.7)
    ?(hv = 3.)
    ?(o = true)
    f  f' (g : ('a,'b) graphe) =
  let n = Array.length g in
  draw_structuregraphique
     {
     elementgraphique = g;
     oriente = o;
     flecherentrante = Array.make n false;
     flechesortante = Array.make n false;
     longueurfleche = 0.;
     fonctionsommet = (function s -> cs,f s);
     fonctionarc = (function s -> ca,f' s);
     ecarthorizontal = eh;
     ecartvertical = ev;
     diametresommet = d;
     largeurboucle = lb;
     distancevaluation = dv;
     hauteurvaluation = hv;
     trespetitecart = ehpp;
     petitecart = ehp;
     rayonangle = ra;
     margehorizontale = mh;
     };;





